<?php

function skype_status_admin_settings() {
  $settings = skype_status_get_settings();
  drupal_add_js(drupal_get_path('module', 'skype_status') . '/inc/skype_status.admin.js');
  $form = array();
  $fields = array();
  $result = db_query("SELECT * FROM {profile_fields} WHERE type = 'textfield' ORDER BY category, weight");
  while ($field = db_fetch_object($result)) {
    $fields[$field->name] = t('%category - @title', array('%category' => $field->category, '@title' => $field->title));
  }
  $images_dirs = array('balloon', 'bigclassic', 'smallclassic', 'mediumicon', 'smallicon');
  $opts = array();
  foreach ($images_dirs as $style) {
    $opts[$style] = theme('image', drupal_get_path('module', 'skype_status') . '/images/' . $style . '/1.png', $style, NULL, array('id' => $style, 'class' => 'skype-status-img-rotate'));
  }

  $form['profile'] = array(
    '#type' => 'fieldset',
    '#title' => t('User profiles'),
    '#tree' => TRUE
  );
  $form['profile']['field'] = array(
    '#type' => 'radios',
    '#title' => t('Profile field for Skype ID'),
    '#options' => $fields,
    '#default_value' => $settings['profile']['field'],
    '#required' => TRUE,
    '#description' => t("Select the custom profile field that contains users' Skype IDs. Note that users who have not filled out this profile field will be ignored when updating status information from Skype\'s web presence service API.")
  );
  $form['profile']['title'] = array(
    '#type' => 'checkbox',
    '#title' => t('Show the title for this field'),
    '#description' => t('Uncheck this box to hide the title for the chosen field.'),
    '#default_value' => $settings['profile']['title'],
  );
  $form['theming'] = array(
    '#type' => 'fieldset',
    '#title' => t('Skype Theming'),
    '#description' => t('Choose the images and other settings you would like to use for Skype status.'),
    '#tree' => TRUE
  );
  $form['theming']['action'] = array(
    '#type' => 'radios',
    '#title' => t('Action'),
    '#description' => t('What to do when clicking on the Skype status button.'),
    '#options' => array(
      'call' => t('Call'),
      'chat' =>t('Chat')
    ),
    '#default_value' => $settings['theming']['action'],
  );
  $form['theming']['buttonstyle'] = array(
    '#type' => 'radios',
    '#title' => t('Button style preference.'),
    '#options' => $opts,
    '#default_value' => $settings['theming']['buttonstyle'],
  );
  $form['#submit'][] = 'skype_status_admin_settings_submit';

  return system_settings_form($form);
}

function skype_status_admin_settings_submit($form, &$form_state) {
  foreach ($form_state['values'] as $key => $value) {
    if (!is_array($value)) {
      unset($form_state['values'][$key]);
    }
  }
  $form_state['values'] = array('skype_status' => $form_state['values']);
}