<?php

class skype_status_handler_field_user extends views_handler_field_user {
  function option_definition() {
    $options = parent::option_definition();
    $options['skype_status_format'] = array('default' => 'skype_status_button');
    $options['skype_status_show_empty'] = array('default' => '1');
    return $options;
  }

  /**
   * Provide link to node option
   */
  function options_form(&$form, &$form_state) {
    parent::options_form($form, $form_state);
    $opts = array(
      'skype_status_button' => 'Skype Button',
      'skype_status_id' => 'Skype ID (plain text)',
    );

    $form['skype_status_format'] = array(
      '#title' => t('Format'),
      '#description' => t('This will override any other link you have set.'),
      '#type' => 'select',
      '#options' => $opts,
      '#default_value' => $this->options['skype_status_format'],
    );
    $form['skype_status_show_empty'] = array(
      '#title' => t("Show empty skype ID's"),
      '#description' => t("If checked empty Skype Id's will be shown as %s [username]", array('%s' => t('Skype ID not set for'))),
      '#type' => 'checkbox',
      '#default_value' => $this->options['skype_status_show_empty'],
    );
    unset($form['link_to_user']);
  }

  function render($values) {
    if (empty($values->{$this->field_alias})) {
      switch ($this->options['skype_status_show_empty']) {
        case '0':
          return '';
        default:
          return t('Skype ID not set for !name', array('!name' => 'user'));
      }
    }
    switch ($this->options['skype_status_format']):
      case 'skype_status_button':
        $settings = skype_status_get_settings();
        $output = theme('skype_status', check_plain($values->{$this->field_alias}), $settings);
        return $output;
      case 'skype_status_id':
        return check_plain($values->{$this->field_alias});
    endswitch;
  }
}
